/***************************************************************
This is really a mess. I've just been adding to the original
widget each new version. And seeing as how this was my first,
it wasn't exactly thought out well. I need to clean this all up
or (most likely) rewrite from scratch. But I'll wait for K:3
to do that. See if we can throw some cool new stuff in with the
new features.
****************************************************************/

// ##### Variables
	mailCount = 0;
	preCount = 0;
	newMail = false;
	testing = false;
 	doCheck.interval= preferences.checkTimer.value;
	widgetVersion = "2.5";

// ######### Onload, do everything
updateTheme();
refresh();
checkVersion();

// ##### Manage Preferences
if (preferences.username.value == "") {
	print("No username on file");
	preferences.username.value = prompt("Username:", "","Please enter your username", "Save", "Cancel");
	print("Saving username: " + preferences.username.value);
}
if (preferences.password.value == "") {
	print("No password on file");
	preferences.password.value = prompt("Password:", "","Please enter your password", "Save", "Cancel");
	print("Saving password: " + preferences.password.value);
}

switch (preferences.theme.value){
	case "Colorized":
		break;
	case "Black Glass":
		break;
	case "None":
		break;
	default:
		preferences.theme.value = "Black Glass";
	break;
}

switch (preferences.icon.value){
	case "Envelope":
		break;
	case "Envelope 2":
		break;
	case "Star":
		break;
	case "Blue G":
		break;
	case "Gmail Logo":
		break;
	default:
		preferences.icon.value = "Star";
		break;
}


// ###### Start the proccess going
function refresh(){
	preCount = mailCount;
	startData();
}


// ##### Data Functions
function startData(){
	var url = new URL();
	//print("Doing Request");
	url.location = "https://"+preferences.username.value+":"+preferences.password.value+"@mail.google.com/mail/feed/atom/" + preferences.checklabel.value;
	url.fetchAsync(parseData);
}

function parseData(dat){
	if(verified(dat.response,dat.result)){
		mailNew = dat.result.match(/<fullcount>(.*?)<\/fullcount>/i);
		if (mailNew) {
			//print(mailNew[1] + " new messages!");
			mailCount = mailNew[1];
		} else {
			//print("No New Mail");
			mailCount = 0;
		}
		wIcon.tooltip = "Click to open Gmail in your browser.";
		screenWrite();
		isNew();
	}
}

function isNew(){
	if (mailCount > preCount) {
		//print("New Mail!");
		newMail = true;
		doOptions();
	}
}


function goTo(){
	if(preferences.autoLogin.value == '1'){
		var loginURL = "https://www.google.com/accounts/ServiceLoginAuth?service=mail&Email=" + preferences.username.value + "&Passwd=" + preferences.password.value + "&continue=https://mail.google.com/mail?ui=html&amp;zy=l";
		openURL(loginURL);
	} else {
		openURL("http://mail.google.com/mail");
	}
}



/****************************
* Verification Functions
****************************/

function verified(rsp,dat){
	var matchUnauth = /<H1>Unauthorized<\/H1>/i;
	var matchFeed = /<feed/i;
	var typ = "";
	var msg = "";

	switch(rsp){
		// Could not connect to server
		case 0:
			error("conn","noserver","");
			return false;
		break;
		default:
			if(dat.match(matchFeed)){
				return true;
			} else {
				if(dat.match(matchUnauth)){
					error("auth","pass","");
					return false;
				} else {
					error("conn","unexpected","There was an unexpected error. This is possibly caused by a proxy that requires you to log in like, possibly Hotel's internet access.");
					return false;
				}
			}
	}
}

function error(cls,typ,msg){
	switch (cls){
		// Connection Problems
		case "conn":
			switch (typ){
				case "noserver":
					print("Could not connect to server");
					wIcon.src = "Resources/icons/noconnection.png";
					wIcon.fade(wIcon.opacity, 255, 10);
					wIcon.tooltip = "Could not connect to server!";
				break;
				case "unexpected":
					print("Unexpected error");
					alert(msg);
				break;
				default:
					print(msg);
				break;
			}
		break;
			
		// Authorization Problems
		case "auth":
			switch (typ){
				case "pass":
					print("Invalid Authorization Credentials");
					wIcon.src = "Resources/icons/badpword.png";
					wIcon.fade(wIcon.opacity, 255, 10);
					wIcon.tooltip = "Incorrect password!";
				break;
			}
		break;

		// Data Problems
		case "data":
			switch (typ){
				case "404":
					print("Page was not found");
				break;
				case "500":
					print("Gmail server had an internal error.");
				break;
			}			
		break;
	}
}

// ####### UI Functions

function doOptions(){
	if (preferences.notify_option.value == '1') {
		if (preferences.notify_sound.value != '') {
			play(preferences.notify_sound.value, true);
		}
	}
	if (preferences.focus_option.value == '1') {
		focusWidget();
	}
	if (preferences.vanish.value == '1') {
		main_window.visible = 1;
	}
}
function updateTheme(){

	wIcon.src = "Resources/icons/" + preferences.icon.value + ".png";
	wIcon.tooltip = preferences.username.value + "@gmail.com";
	doCheck.interval= preferences.checkTimer.value;
	
	switch (preferences.theme.value)
	{
		case "Colorized":
			shine.src = "Resources/Colorized/body_shine.png";
			overlay.src = "Resources/Colorized/body_overlay.png";
			body.src = "Resources/Colorized/body_base.png";
			overlay.colorize = preferences.bgColor.value;
			body.colorize = preferences.bgColor.value;
			break;
		case "Black Glass":
			shine.src = "Resources/Black Glass/body_shine.png";
			overlay.src = "Resources/Black Glass/body_overlay.png";
			body.src = "Resources/Black Glass/body_base.png";
			break;
		case "None":
			shine.src = "";
			overlay.src = "";
			body.src = "";
			break;
	}
	doLabel();
}
function doLabel(){
	if(preferences.showLabel.value == '1'){
		lblShadow.opacity = "255";
		lblAccount.opacity = "255";
		lblAccount.color = preferences.lblColor.value;
		switch (preferences.labelType.value){
			case "account":
				lblShadow.data = preferences.username.value;
				lblAccount.data = preferences.username.value;
				break;
			case "label":
				lblShadow.data = preferences.checklabel.value;
				lblAccount.data = preferences.checklabel.value;
				break;
			case "custom":
				lblShadow.data = preferences.labelCustom.value;
				lblAccount.data = preferences.labelCustom.value;
				break;
		}
	
	} else {
		lblShadow.opacity = "0";
		lblAccount.opacity = "0";
	}
}

function screenWrite(){
	count = String(mailCount);
	if (count.length == 1) {
		count = "b" + String(count);
	}

	if (count == "b0") {
		count = "bb";
		wIcon.src = "Resources/icons/" + preferences.icon.value + ".png";
		wIcon.fade(wIcon.opacity, 100, 10);
		if (preferences.vanish.value == 1) {
			main_window.visible = 0;
		}
	}
	if (count != "bb") {
		wIcon.src = "Resources/icons/" + preferences.icon.value + ".png";
		wIcon.fade(wIcon.opacity, 255, 10);
	}
	if (count > 99) {
		count = "99";
	}
	ten.src = "Resources/LCD/" + count.substr(0,1) + ".png";
	one.src = "Resources/LCD/" + count.substr(1,1) + ".png";
}

function checkVersion(){
	print("Checking for new version");
	var url = new URL();
	url.location = "http://widgets.clearspanmedia.com/updates/?widget=gmailgeiger&version=" + widgetVersion;
	url.fetchAsync(notifyVersion);
}
function notifyVersion(dat){
	if(dat.response != 0){
		if(dat.result == "new"){
			print("New Version Available!");
			askNew = alert("A new version of GmailGeiger is available.", "Download", "Ignore");
			if(askNew == 1){
				openURL("http://widgets.clearspanmedia.com/gmailgeiger/?a=newversion");
			}
		}
	}
}